//********************************************************************
//*** POSIX/timer.hh
//*** Copyright (c) 2003 by Markus Winand <mws@fatalmind.com>
//*** $Id: timer.hh,v 1.7 2003/10/26 19:50:38 mws Exp $
//********************************************************************

#ifndef POSIX_TIMER_HH
#define POSIX_TIMER_HH

#ifndef INCLUDED_THREAD_LOCK_HH
#include "Thread/LockFwd.hh"
#endif

// forward declarations
namespace fatalmind {
	template <class TMTS, class TM> class timer;

	class nopTimer;
}


#ifndef POSIX_TIME_HH
#include "POSIX/time.hh"
#endif

#include <time.h>
//#include <iostream>


namespace fatalmind {

//using fatalmind::POSIX::timespec;

template<class TMTS, class TM>
class timer {
    public:
        timer(POSIX::timespec<TMTS>& tm, bool start);
        ~timer();

		void start();
		void stop();

        //friend std::ostream& operator<<(std::ostream&, const timer&);
	private:
		timer(timer&); // c-ctor
		POSIX::timespec<TM> _start;
		POSIX::timespec<TMTS>& _tm;
		bool _running;
};

class nopTimer {
	public:
		inline nopTimer(int i, bool start) {
		}
		inline ~nopTimer() {};

		inline void start() {};
		inline void stop() {};
	private:
		nopTimer(nopTimer&); // c-ctor
};

//std::ostream& operator<<(std::ostream&, const timer&);

} // namespace fatalmind


#endif

