//********************************************************************
//*** ResourcePool/mysql/Factory.hh
//*** Copyright (c) 2003 by Markus Winand <mws@fatalmind.com>
//*** $Id: Factory.hh,v 1.1 2003/01/29 20:44:33 mws Exp $
//********************************************************************

#ifndef RESOURCEPOOL_MYSQL_FACTORY_HH
#define RESOURCEPOOL_MYSQL_FACTORY_HH

#ifndef RESOURCEPOOL_MYSQL_RESOURCE_HH
#include "Resource.hh"
#endif

#include <string>

namespace fatalmind {

class mysqlFactory {
	public:
		mysqlFactory(const std::string& host
			, const std::string& user
			, const std::string& pass
			, const std::string& db
			, unsigned int port = 3306
			, const std::string& sock = ""
		);
	
		mysqlResource* create_resource() const;
			
	private:
		const std::string _host;
		const std::string _user;
		const std::string _pass;
		const std::string _db;
		const unsigned int _port;
		const std::string _sock;
};

//bool operator<(const MYSQL* lho, const MYSQL* rho);
} // namespace fatalmind
#endif
