//********************************************************************
//*** ResourcePool/mysql/Resource.hh
//*** Copyright (c) 2003 by Markus Winand <mws@fatalmind.com>
//*** $Id: Resource.hh,v 1.2 2003/09/14 08:25:53 mws Exp $
//********************************************************************

#ifndef RESOURCEPOOL_MYSQL_RESOURCE_HH
#define RESOURCEPOOL_MYSQL_RESOURCE_HH

#ifndef RESOURCEPOOL_MYSQL_MYSQLFWD_HH
#include "mysqlFwd.hh"
#endif

#include <string>

namespace fatalmind {

class mysqlResource {
    public:
        mysqlResource(const std::string& host
            , const std::string& user
            , const std::string& pass
            , const std::string& db
            , unsigned int port = 3306
            , const std::string& sock = ""
        );
		~mysqlResource();
		bool precheck();
		bool postcheck();
		void close();
		void fail_close();
		MYSQL& get_plain_resource();

    private:
        MYSQL*   _dbh;
};

} // namespace fatalmind
#endif
