//********************************************************************
//*** ResourcePool/mysql/ResourcePool.hh
//*** Copyright (c) 2003 by Markus Winand <mws@fatalmind.com>
//*** $Id: ResourcePool.hh,v 1.4 2004/06/20 12:16:00 mws Exp $
//********************************************************************

#ifndef RESOURCEPOOL_MYSQL_RESOURCEPOOL_HH
#define RESOURCEPOOL_MYSQL_RESOURCEPOOL_HH

#ifndef RESOURCEPOOL_MYSQL_RESOURCE_HH
#include "ResourcePool/mysql/Resource.hh"
#endif

#ifndef RESOURCEPOOL_MYSQL_FACTORY_HH
#include "ResourcePool/mysql/Factory.hh"
#endif

#ifndef RESOURCEPOOL_RESOURCEPOOL_HH
#include "ResourcePool/ResourcePool.hh"
#endif

#ifndef RESOURCEPOOL_MYSQL_SQLEXECUTE_HH
#include "SQLExecute.hh"
#endif

#ifndef RESOURCEPOOL_MYSQL_SQLSELECT_HH
#include "SQLSelect.hh"
#endif

#ifndef RESOURCEPOOL_MYSQL_SQLSELECTROW_HH
#include "SQLSelectRow.hh"
#endif

#ifndef RESOURCEPOOL_MYSQL_MYSQLEXCEPTION_HH
#include "MysqlException.hh"
#endif

namespace fatalmind {
namespace ResourceType {

struct mysqlCommands {
	typedef fatalmind::mysql::SQLExecute   SQLExecute;
	typedef fatalmind::mysql::SQLSelect    SQLSelect;
	typedef fatalmind::mysql::SQLSelectRow SQLSelectRow;
};

/**
 * The resource type to access mysql databases.
 */
typedef PoolType<mysqlFactory, mysqlResource, MYSQL, mysqlCommands> mysql;

} // namespace ResourcePool

namespace mysql {
/**
 * The resource type to access mysql databases.
 */
class ResourceType 
: public fatalmind::ResourceType::mysql
{
};
}
} // namespace fatalmind

#endif
