//********************************************************************
//*** ResourcePool/mysql/SQLExecute.hh
//*** Copyright (c) 2003 by Markus Winand <mws@fatalmind.com>
//*** $Id: SQLExecute.cc,v 1.13 2003/10/09 19:56:38 mws Exp $
//********************************************************************

#include "SQLExecute.hh"

#include "lex.mysql_bind.hh"
//#include "ResourcePool/ResourcePool.hh"

#ifndef INCLUDED_EXCEPTIONS_HH
#include "Exceptions/Exception.hh"
#endif

#ifndef RESOURCEPOOL_MYSQL_SQLTYPE_HH
#include "SQLType.hh"
#endif

#ifndef RESOURCEPOOL_MYSQL_MYSQLEXCEPTION_HH
#include "MysqlException.hh"
#endif

#include "ResourcePool/SQL/Bind.cc"
//#include "SQLType.cc"

#include <mysql/mysql.h>

namespace fatalmind {
namespace mysql {

SQLExecute::SQLExecute(const std::string& SQL)
: _SQL(SQL)
{
}

SQLExecute::~SQLExecute()
{
}

void SQLExecute::execute(MYSQL& dbh)
{
	mysql_bind boundsql(dbh, _SQL, _args);
	if (int rc = mysql_real_query(&dbh
		, boundsql.getSQL().c_str()
		, boundsql.getSQL().length())
	) {
		MysqlException::throwit(rc, mysql_error(&dbh), mysql_errno(&dbh), _SQL);
	}
}

} // namespace mysql

template class
SQL::Bind<mysql::SQLType, mysql::SQLTypeImpl>;

} // namespace fatalmind
