//********************************************************************
//*** ResourcePool/mysql/SQLSelectRow.cc
//*** Copyright (c) 2003 by Markus Winand <mws@fatalmind.com>
//*** $Id: SQLSelectRow.cc,v 1.7 2003/10/27 21:27:38 mws Exp $
//********************************************************************

#ifndef RESOURCEPOOL_MYSQL_SQLSELECTROW_HH
#include "SQLSelectRow.hh"
#endif

#ifndef RESOURCEPOOL_MYSQL_MYSQLEXCEPTION_HH
#include "MysqlException.hh"
#endif

#include <sstream>

#include <mysql/mysql.h>

namespace fatalmind {
namespace mysql {

SQLSelectRow::SQLSelectRow(
	const std::string& SQL
)
: SQLSelect(SQL)
, _row(0)
{
}

void SQLSelectRow::execute(MYSQL& dbh)
{
	_row = 0;
	SQLSelect::execute(dbh);
	if (_row == 0) {
		throw NFOMysqlException("NO DATA", 99, _SQL);
	}
}

bool SQLSelectRow::process() {
	if (++_row < 2) {
		return true;
	} else {
		throw NFOMysqlException("Result consisted of more than one row", 1172, _SQL);
	}
}

}
}
