
#ifndef RESOURCEPOOL_MYSQL_MYSQLBIND_HH
#define RESOURCEPOOL_MYSQL_MYSQLBIND_HH

#ifndef RESOURCEPOOL_MYSQL_SQLTYPE_HH
#include "SQLType.hh"
#endif

#ifndef INCLUDED_GC_PTR_HH
#include "mm/gc_ptr.hh"
#endif

#include <vector>
#include <string>
//#include <iostream>
#include <sstream>


#ifndef MYSQL_INCLUDE_FLEXLEXER
#undef yyFlexLexer
#define yyFlexLexer mysql_bindFlexLexer
#include <FlexLexer.h>
#endif

//using namespace fatalmind::mysql;

namespace fatalmind {
namespace mysql {

class mysql_bind: public mysql_bindFlexLexer {
	public:
		mysql_bind(MYSQL& dbh, const std::string& _sql, const std::vector<gc_ptr<SQLType> >& args);
		const std::string& getSQL();
	private:
		const SQLType& get_mysql_arg();
		int yylex ();
	
		unsigned int _arg_no;
		std::ostringstream _os;
		std::istringstream _is;
		const std::vector<gc_ptr<SQLType> >& _args;
		std::string _sqlout;
		MYSQL& _dbh;
};
} // namespace mysql
} // namespace fatalmind

extern "C" {
inline int mysql_bindwrap() {
	return 1;
}
}
#endif
