typedef fatalmind::ResourcePool<fatalmind::ResourceType::mysql> RP;

std::string getHost() {
	return std::string(getenv("FATALMIND_RESOURCEPOOL_MYSQL_HOST"));
}

std::string getDatabase() {
	return std::string(getenv("FATALMIND_RESOURCEPOOL_MYSQL_DATABASE"));
}

std::string getUser() {
	return std::string(getenv("FATALMIND_RESOURCEPOOL_MYSQL_USER"));
}

std::string getPass() {
	return std::string(getenv("FATALMIND_RESOURCEPOOL_MYSQL_PASS"));
}


RP::Factory getFactory() {
	return RP::Factory(getHost(), getUser(), getPass(), getDatabase());
}

void init(RP& p) {
	RP::Command::SQLExecute sql(
		"create table hirsch (id numeric not null primary key, ukn varchar(255))"
	);
	p.execute(sql);
}

void clear(RP& p) {
	RP::Command::SQLExecute sql("delete from hirsch");
	p.execute(sql);
}

void drop(RP& p) {
	try {
		RP::Command::SQLExecute sql("drop table hirsch");
		p.execute(sql);
	} catch (...) {
	}
}

