#include <iostream>
#include "ResourcePool/oracle/ResourcePool.hh"
                                          /* define the resource type to use */
typedef fatalmind::ResourcePool<fatalmind::ResourceType::oracle> RP;

int main(int argc, char* argv[]) {
	try {
		if (argc < 4) {                   /* just some minimalistic checking */
			throw fatalmind::Exception("arguments missing: [TNS] [user] [pass]");
		}
		RP::Factory f(argv[1], argv[2], argv[3]); /* pass the arguments to the factory */
		RP r(f);                          /* create a resource pool */
	
		RP::Command::SQLSelectRow select("select to_char(sysdate) from dual");
		std::string result;               /* prepare the command object to be executed */
		select.bindout(0, result);        /* provide the place were we expect the result */
	
		r.execute(select);                /* execute the SQL */
	
		std::cout << "Result: " << result << std::endl; /* print the result */
	} catch (fatalmind::Exception e) {    /* if you provide missing/wrong data */
		std::cout << "An error happend: " << e.message() << std::endl;
	}
}
